/*
   Testproblem 1: 1D Fouriertransformation
*/

#include <stdio.h>
#include <math.h>
#include "cppmacro.h"
#include <spp_prog_model.h>

typedef struct {
          double real,imag;
	} complex;

int main() {
  int i,j,n;
  double *f;
  complex *F;

  printf("ex4: Schleifenparallelisierung, Threadkonzept.\n");
  printf("     Das Programm berechnet die diskrete 1-dimensionale Fouriertransformation\n");
  printf("     der Abbildung f(x)=1, ohne Ausgabe nur als simples Beispiel fuer die\n");
  printf("     Schleifenparallelisierung.\n");
  printf("     (c) N. Schmeisser, FVTK, FZ Rossendorf, 1996\n");

  n=5000;

  F=new(complex,n);

  #pragma _CNX loop_parallel(ivar=i), loop_private(j)
  for (i=0;i<n;i++) {
    F[i].real=0;
    F[i].imag=0;
    for (j=0;j<n;j++) {
      F[i].real+=sin((double)(i*j));
      F[i].imag+=cos((double)(i*j));
    }
    
  }

  delete(F);

  return 0;
}
