#include <stdio.h>
#include <spp_prog_model.h>

unsigned long MAXCALLS;
unsigned long count[100];
unsigned long s;

void t(int tid) {
  do {

    // count[tid] wird exclusiv von Thread tid benutzt, ist also unabhaengig von
    // allen anderen Threads

    count[tid]++;

    // s ist eine gemeinsame Variable (-> Shared Memory), deshalb darf ein Zugriff
    // nur unter wechselseitigem Ausschluss stattfinden, d.h. befindet sich ein
    // Thread im -> kritischen Bereich, so muss allen anderen dwer Zugang verwehrt
    // werden.
    // Ueber die Implementation ist zunaechst noch nichts genaueres bekannt. U.U.
    // muessen die Pragmas durch eine eigen Implementation fairer Ausschlussalgorithem
    // (z.B. von Dijkstra, ...) ersetzt werden.

    #pragma _CNX critical_section
      s++;
    #pragma _CNX end_critical_section
  } while (s<MAXCALLS);
}

int main(int argc,char **argv) {
  int i;

  printf("ex5: Parallelisierung von nicht-Schleifen Sequenzen, kritische Bereiche.\n");
  printf("     Aufruf: ex5 <Anzahl Durchlaeufe>\n");
  printf("     (c) N. Schmeisser, FVTK, FZ Rossendorf, 1996\n");

  s=0;
  for (i=0;i<100;i++) count[i]=0;
  sscanf(argv[1],"%d",&MAXCALLS);

  // Die folgenden Tasks werden auf 15 Threads aufgeteilt und laufen dort parallel

  #pragma _CNX begin_tasks
    t(0);
  #pragma _CNX next_task
    t(1);
  #pragma _CNX next_task
    t(2);
  #pragma _CNX next_task
    t(3);
  #pragma _CNX next_task
    t(4);
  #pragma _CNX next_task
    t(5);
  #pragma _CNX next_task
    t(6);
  #pragma _CNX next_task
    t(7);
  #pragma _CNX next_task
    t(8);
  #pragma _CNX next_task
    t(9);
  #pragma _CNX next_task
    t(10);
  #pragma _CNX next_task
    t(11);
  #pragma _CNX next_task
    t(12);
  #pragma _CNX next_task
    t(13);
  #pragma _CNX end_tasks

  for (i=0;i<14;i++)
    printf("Task %d got %10d calls.\n",i,count[i]);
  return 0;
}





