#include <stdio.h>
#include <spp_prog_model.h>
#include <cps.h>

static node_private barrier_t barrier;

void test_thread(void *c) {
  static thread_private int count;
  static thread_private ktid_t myid;
  static thread_private char s[256];

  // Parameteruebergabe vom Aufrufenden

  count=*((int*)c);

  // Ermitteln der Kernel-Thread-ID

  myid=cps_ktid();

  printf("Hello world from %d, waiting for %d threads running.\n",myid,count);
  printf("Thread %d reports: %d threads are running.\n",myid,cps_complex_nthreads());

  // Warten, bis count Threads an der Barriere eingetroffen sind -> Sperrsynchronisation

  cps_barrier(&barrier,&count);
}

int main(int argc,char **argv) {
  int i,n;
  int node;
  int flag=0;

  printf("ex7: Dynamische Erzeugung von Threads und Synchronisation.\n");
  printf("     Aufruf: ex7 <anzahl>\n");
  printf("     Das Programm erzeugt iterativ <anzahl> Threads, fuehrt eine Sperr-\n");
  printf("     synchronisation aus und terminiert.\n");
  printf("     Falls das Programm haengen sollte (Deadlock), mit\n");
  printf("     'mpa -m -min <anzahl> -max <anzahl> ex7'\n");
  printf("     die Anzahl der Threads erhoehen.\n");
  printf("     (c) N. Schmeisser, FVTK, FZ Rossendorf, 1996\n");

  if (argc==2) {
    sscanf(argv[1],"%d",&n);

    // Barriere vorbereiten, siehe dazu auch ex6.c

    cps_barrier_alloc(&barrier);

    // Creating n threads running test_thread 
    // and passing count as argument

    // Auf einem beliebigen Hypernode erzeugen

    node=CPS_ANY_NODE;

    // Iterativer Start aller Threads

    for (i=0;i<n;i++) {
      printf("Erzeugen von Thread %d, status=%d.\n",i+1,
	     cps_thread_create(&node,test_thread,(void*)(&n)));
    }

    // Ist flag=0, so gibt die Funktion die Anzahl der Kind-Threads zurueck
    // Ist flag=1, so wartet die Funktion, bis alle Kind-Threads terminiert haben

    while (cps_thread_wait(&flag)>0);

    // Barriere loeschen

    cps_barrier_free(&barrier);
  }

  return 0;
}
